/**************************************************************************
 * Copyright (C) 2012-2021  Unisound
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 **************************************************************************
 *
 * Description : multicore_lock.h
 * Author      : yzs.unisound.com
 * Date        : 2021.03.01
 *
 **************************************************************************/
#ifndef __MULTICORE_LOCK_H__
#define __MULTICORE_LOCK_H__

#include <autoconf.h>

typedef enum {
	MULTICORE_LOCK_OTP = (1 << 0),
} MULTICORE_LOCK;

#ifdef CONFIG_MULTICORE_LOCK

int multicore_trylock(MULTICORE_LOCK lock);
int multicore_lock(MULTICORE_LOCK lock);
int multicore_unlock(MULTICORE_LOCK lock);

#else

inline int multicore_trylock(MULTICORE_LOCK lock)
{
	return 0;
}

inline int multicore_lock(MULTICORE_LOCK lock)
{
	return 0;
}

inline int multicore_unlock(MULTICORE_LOCK lock)
{
	return 0;
}
#endif

#endif
